OGRE: Ogre::AutoParamDataSource Class Reference - OGRE Documentation

Public Member Functions | Protected Member Functions | Protected Attributes

# Ogre::AutoParamDataSource Class Reference
[Materials]

This utility class is used to hold the information used to generate the matrices and other information required to automatically populate GpuProgramParameters. More...

`#include <OgreAutoParamDataSource.h>`

Inheritance diagram for Ogre::AutoParamDataSource:
[legend]

List of all members.

## Public Member Functions
| AutoParamDataSource ()
virtual | ~AutoParamDataSource ()
virtual void | setCurrentRenderable (const Renderable *rend)
| Updates the current renderable.
virtual void | setWorldMatrices (const Matrix4 *m, size_t count)
| Sets the world matrices, avoid query from renderable again.
virtual void | setCurrentCamera (const Camera *cam, bool useCameraRelative)
| Updates the current camera.
virtual void | setCurrentLightList (const LightList *ll)
| Sets the light list that should be used, and it's base index from the global list.
virtual void | setTextureProjector (const Frustum *frust, size_t index)
| Sets the current texture projector for a index.
virtual void | setCurrentRenderTarget (const RenderTarget *target)
| Sets the current render target.
virtual void | setCurrentViewport (const Viewport *viewport)
| Sets the current viewport.
virtual void | setShadowDirLightExtrusionDistance (Real dist)
| Sets the shadow extrusion distance to be used for point lights.
virtual void | setMainCamBoundsInfo (VisibleObjectsBoundsInfo *info)
| Sets the main camera's scene bounding information.
virtual void | setCurrentSceneManager (const SceneManager *sm)
| Set the current scene manager for enquiring on demand.
virtual void | setCurrentPass (const Pass *pass)
| Sets the current pass.
virtual const Matrix4 & | getWorldMatrix (void) const
virtual const Matrix4 * | getWorldMatrixArray (void) const
virtual size_t | getWorldMatrixCount (void) const
virtual const Matrix4 & | getViewMatrix (void) const
virtual const Matrix4 & | getViewProjectionMatrix (void) const
virtual const Matrix4 & | getProjectionMatrix (void) const
virtual const Matrix4 & | getWorldViewProjMatrix (void) const
virtual const Matrix4 & | getWorldViewMatrix (void) const
virtual const Matrix4 & | getInverseWorldMatrix (void) const
virtual const Matrix4 & | getInverseWorldViewMatrix (void) const
virtual const Matrix4 & | getInverseViewMatrix (void) const
virtual const Matrix4 & | getInverseTransposeWorldMatrix (void) const
virtual const Matrix4 & | getInverseTransposeWorldViewMatrix (void) const
virtual const Vector4 & | getCameraPosition (void) const
virtual const Vector4 & | getCameraPositionObjectSpace (void) const
virtual const Vector4 & | getLodCameraPosition (void) const
virtual const Vector4 & | getLodCameraPositionObjectSpace (void) const
virtual bool | hasLightList () const
virtual float | getLightNumber (size_t index) const
| Get the light which is 'index'th closest to the current object.
virtual float | getLightCount () const
virtual float | getLightCastsShadows (size_t index) const
virtual const ColourValue & | getLightDiffuseColour (size_t index) const
virtual const ColourValue & | getLightSpecularColour (size_t index) const
virtual const ColourValue | getLightDiffuseColourWithPower (size_t index) const
virtual const ColourValue | getLightSpecularColourWithPower (size_t index) const
virtual const Vector3 & | getLightPosition (size_t index) const
virtual Vector4 | getLightAs4DVector (size_t index) const
virtual const Vector3 & | getLightDirection (size_t index) const
virtual Real | getLightPowerScale (size_t index) const
virtual Vector4 | getLightAttenuation (size_t index) const
virtual Vector4 | getSpotlightParams (size_t index) const
virtual void | setAmbientLightColour (const ColourValue &ambient)
virtual const ColourValue & | getAmbientLightColour (void) const
virtual const ColourValue & | getSurfaceAmbientColour (void) const
virtual const ColourValue & | getSurfaceDiffuseColour (void) const
virtual const ColourValue & | getSurfaceSpecularColour (void) const
virtual const ColourValue & | getSurfaceEmissiveColour (void) const
virtual Real | getSurfaceShininess (void) const
virtual ColourValue | getDerivedAmbientLightColour (void) const
virtual ColourValue | getDerivedSceneColour (void) const
virtual void | setFog (FogMode mode, const ColourValue &colour, Real expDensity, Real linearStart, Real linearEnd)
virtual const ColourValue & | getFogColour (void) const
virtual const Vector4 & | getFogParams (void) const
virtual const Matrix4 & | getTextureViewProjMatrix (size_t index) const
virtual const Matrix4 & | getTextureWorldViewProjMatrix (size_t index) const
virtual const Matrix4 & | getSpotlightViewProjMatrix (size_t index) const
virtual const Matrix4 & | getSpotlightWorldViewProjMatrix (size_t index) const
virtual const Matrix4 & | getTextureTransformMatrix (size_t index) const
virtual const RenderTarget * | getCurrentRenderTarget (void) const
virtual const Renderable * | getCurrentRenderable (void) const
virtual const Pass * | getCurrentPass (void) const
virtual Vector4 | getTextureSize (size_t index) const
virtual Vector4 | getInverseTextureSize (size_t index) const
virtual Vector4 | getPackedTextureSize (size_t index) const
virtual Real | getShadowExtrusionDistance (void) const
virtual const Vector4 & | getSceneDepthRange () const
virtual const Vector4 & | getShadowSceneDepthRange (size_t index) const
virtual const ColourValue & | getShadowColour () const
virtual Matrix4 | getInverseViewProjMatrix (void) const
virtual Matrix4 | getInverseTransposeViewProjMatrix () const
virtual Matrix4 | getTransposeViewProjMatrix () const
virtual Matrix4 | getTransposeViewMatrix () const
virtual Matrix4 | getInverseTransposeViewMatrix () const
virtual Matrix4 | getTransposeProjectionMatrix () const
virtual Matrix4 | getInverseProjectionMatrix () const
virtual Matrix4 | getInverseTransposeProjectionMatrix () const
virtual Matrix4 | getTransposeWorldViewProjMatrix () const
virtual Matrix4 | getInverseWorldViewProjMatrix () const
virtual Matrix4 | getInverseTransposeWorldViewProjMatrix () const
virtual Matrix4 | getTransposeWorldViewMatrix () const
virtual Matrix4 | getTransposeWorldMatrix () const
virtual Real | getTime (void) const
virtual Real | getTime_0_X (Real x) const
virtual Real | getCosTime_0_X (Real x) const
virtual Real | getSinTime_0_X (Real x) const
virtual Real | getTanTime_0_X (Real x) const
virtual Vector4 | getTime_0_X_packed (Real x) const
virtual Real | getTime_0_1 (Real x) const
virtual Real | getCosTime_0_1 (Real x) const
virtual Real | getSinTime_0_1 (Real x) const
virtual Real | getTanTime_0_1 (Real x) const
virtual Vector4 | getTime_0_1_packed (Real x) const
virtual Real | getTime_0_2Pi (Real x) const
virtual Real | getCosTime_0_2Pi (Real x) const
virtual Real | getSinTime_0_2Pi (Real x) const
virtual Real | getTanTime_0_2Pi (Real x) const
virtual Vector4 | getTime_0_2Pi_packed (Real x) const
virtual Real | getFrameTime (void) const
virtual Real | getFPS () const
virtual Real | getViewportWidth () const
virtual Real | getViewportHeight () const
virtual Real | getInverseViewportWidth () const
virtual Real | getInverseViewportHeight () const
virtual Vector3 | getViewDirection () const
virtual Vector3 | getViewSideVector () const
virtual Vector3 | getViewUpVector () const
virtual Real | getFOV () const
virtual Real | getNearClipDistance () const
virtual Real | getFarClipDistance () const
virtual int | getPassNumber (void) const
virtual void | setPassNumber (const int passNumber)
virtual void | incPassNumber (void)
virtual void | updateLightCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Member Functions
const Light & | getLight (size_t index) const
## Protected Attributes
Matrix4 | mWorldMatrix [256]
size_t | mWorldMatrixCount
const Matrix4 * | mWorldMatrixArray
Matrix4 | mWorldViewMatrix
Matrix4 | mViewProjMatrix
Matrix4 | mWorldViewProjMatrix
Matrix4 | mInverseWorldMatrix
Matrix4 | mInverseWorldViewMatrix
Matrix4 | mInverseViewMatrix
Matrix4 | mInverseTransposeWorldMatrix
Matrix4 | mInverseTransposeWorldViewMatrix
Vector4 | mCameraPosition
Vector4 | mCameraPositionObjectSpace
Matrix4 | mTextureViewProjMatrix [OGRE_MAX_SIMULTANEOUS_LIGHTS]
Matrix4 | mTextureWorldViewProjMatrix [OGRE_MAX_SIMULTANEOUS_LIGHTS]
Matrix4 | mSpotlightViewProjMatrix [OGRE_MAX_SIMULTANEOUS_LIGHTS]
Matrix4 | mSpotlightWorldViewProjMatrix [OGRE_MAX_SIMULTANEOUS_LIGHTS]
Vector4 | mShadowCamDepthRanges [OGRE_MAX_SIMULTANEOUS_LIGHTS]
Matrix4 | mViewMatrix
Matrix4 | mProjectionMatrix
Real | mDirLightExtrusionDistance
Vector4 | mLodCameraPosition
Vector4 | mLodCameraPositionObjectSpace
bool | mWorldMatrixDirty
bool | mViewMatrixDirty
bool | mProjMatrixDirty
bool | mWorldViewMatrixDirty
bool | mViewProjMatrixDirty
bool | mWorldViewProjMatrixDirty
bool | mInverseWorldMatrixDirty
bool | mInverseWorldViewMatrixDirty
bool | mInverseViewMatrixDirty
bool | mInverseTransposeWorldMatrixDirty
bool | mInverseTransposeWorldViewMatrixDirty
bool | mCameraPositionDirty
bool | mCameraPositionObjectSpaceDirty
bool | mTextureViewProjMatrixDirty [OGRE_MAX_SIMULTANEOUS_LIGHTS]
bool | mTextureWorldViewProjMatrixDirty [OGRE_MAX_SIMULTANEOUS_LIGHTS]
bool | mSpotlightViewProjMatrixDirty [OGRE_MAX_SIMULTANEOUS_LIGHTS]
bool | mSpotlightWorldViewProjMatrixDirty [OGRE_MAX_SIMULTANEOUS_LIGHTS]
bool | mShadowCamDepthRangesDirty [OGRE_MAX_SIMULTANEOUS_LIGHTS]
ColourValue | mAmbientLight
ColourValue | mFogColour
Vector4 | mFogParams
int | mPassNumber
Vector4 | mSceneDepthRange
bool | mSceneDepthRangeDirty
bool | mLodCameraPositionDirty
bool | mLodCameraPositionObjectSpaceDirty
const Renderable * | mCurrentRenderable
const Camera * | mCurrentCamera
bool | mCameraRelativeRendering
Vector3 | mCameraRelativePosition
const LightList * | mCurrentLightList
const Frustum * | mCurrentTextureProjector [OGRE_MAX_SIMULTANEOUS_LIGHTS]
const RenderTarget * | mCurrentRenderTarget
const Viewport * | mCurrentViewport
const SceneManager * | mCurrentSceneManager
const VisibleObjectsBoundsInfo * | mMainCamBoundsInfo
const Pass * | mCurrentPass
Light | mBlankLight

## Detailed Description

This utility class is used to hold the information used to generate the matrices and other information required to automatically populate GpuProgramParameters.

Remarks:
  This class exercises a lazy-update scheme in order to avoid having to update all the information a GpuProgramParameters class could possibly want all the time. It relies on the SceneManager to update it when the base data has changed, and will calculate concatenated matrices etc only when required, passing back precalculated matrices when they are requested more than once when the underlying information has not altered.

Definition at line 60 of file OgreAutoParamDataSource.h.

## Constructor & Destructor Documentation

Ogre::AutoParamDataSource::AutoParamDataSource | ( |  | ) |

virtual Ogre::AutoParamDataSource::~AutoParamDataSource | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual const ColourValue& Ogre::AutoParamDataSource::getAmbientLightColour | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getCameraPosition | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getCameraPositionObjectSpace | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getCosTime_0_1 | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getCosTime_0_2Pi | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getCosTime_0_X | ( | Real | x | ) | const`[virtual]`

virtual const Pass* Ogre::AutoParamDataSource::getCurrentPass | ( | void |  | ) | const`[virtual]`

virtual const Renderable* Ogre::AutoParamDataSource::getCurrentRenderable | ( | void |  | ) | const`[virtual]`

virtual const RenderTarget* Ogre::AutoParamDataSource::getCurrentRenderTarget | ( | void |  | ) | const`[virtual]`

virtual ColourValue Ogre::AutoParamDataSource::getDerivedAmbientLightColour | ( | void |  | ) | const`[virtual]`

virtual ColourValue Ogre::AutoParamDataSource::getDerivedSceneColour | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getFarClipDistance | ( |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getFogColour | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getFogParams | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getFOV | ( |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getFPS | ( |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getFrameTime | ( | void |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseProjectionMatrix | ( |  | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getInverseTextureSize | ( | size_t | index | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseTransposeProjectionMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseTransposeViewMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseTransposeViewProjMatrix | ( |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getInverseTransposeWorldMatrix | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getInverseTransposeWorldViewMatrix | ( | void |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseTransposeWorldViewProjMatrix | ( |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getInverseViewMatrix | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getInverseViewportHeight | ( |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getInverseViewportWidth | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseViewProjMatrix | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getInverseWorldMatrix | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getInverseWorldViewMatrix | ( | void |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getInverseWorldViewProjMatrix | ( |  | ) | const`[virtual]`

const Light& Ogre::AutoParamDataSource::getLight | ( | size_t | index | ) | const`[protected]`

virtual Vector4 Ogre::AutoParamDataSource::getLightAs4DVector | ( | size_t | index | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getLightAttenuation | ( | size_t | index | ) | const`[virtual]`

virtual float Ogre::AutoParamDataSource::getLightCastsShadows | ( | size_t | index | ) | const`[virtual]`

virtual float Ogre::AutoParamDataSource::getLightCount | ( |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getLightDiffuseColour | ( | size_t | index | ) | const`[virtual]`

virtual const ColourValue Ogre::AutoParamDataSource::getLightDiffuseColourWithPower | ( | size_t | index | ) | const`[virtual]`

virtual const Vector3& Ogre::AutoParamDataSource::getLightDirection | ( | size_t | index | ) | const`[virtual]`

virtual float Ogre::AutoParamDataSource::getLightNumber | ( | size_t | index | ) | const`[virtual]`

Get the light which is 'index'th closest to the current object.

virtual const Vector3& Ogre::AutoParamDataSource::getLightPosition | ( | size_t | index | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getLightPowerScale | ( | size_t | index | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getLightSpecularColour | ( | size_t | index | ) | const`[virtual]`

virtual const ColourValue Ogre::AutoParamDataSource::getLightSpecularColourWithPower | ( | size_t | index | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getLodCameraPosition | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getLodCameraPositionObjectSpace | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getNearClipDistance | ( |  | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getPackedTextureSize | ( | size_t | index | ) | const`[virtual]`

virtual int Ogre::AutoParamDataSource::getPassNumber | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getProjectionMatrix | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getSceneDepthRange | ( |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getShadowColour | ( |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getShadowExtrusionDistance | ( | void |  | ) | const`[virtual]`

virtual const Vector4& Ogre::AutoParamDataSource::getShadowSceneDepthRange | ( | size_t | index | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getSinTime_0_1 | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getSinTime_0_2Pi | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getSinTime_0_X | ( | Real | x | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getSpotlightParams | ( | size_t | index | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getSpotlightViewProjMatrix | ( | size_t | index | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getSpotlightWorldViewProjMatrix | ( | size_t | index | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getSurfaceAmbientColour | ( | void |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getSurfaceDiffuseColour | ( | void |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getSurfaceEmissiveColour | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getSurfaceShininess | ( | void |  | ) | const`[virtual]`

virtual const ColourValue& Ogre::AutoParamDataSource::getSurfaceSpecularColour | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTanTime_0_1 | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTanTime_0_2Pi | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTanTime_0_X | ( | Real | x | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getTextureSize | ( | size_t | index | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getTextureTransformMatrix | ( | size_t | index | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getTextureViewProjMatrix | ( | size_t | index | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getTextureWorldViewProjMatrix | ( | size_t | index | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTime | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTime_0_1 | ( | Real | x | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getTime_0_1_packed | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTime_0_2Pi | ( | Real | x | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getTime_0_2Pi_packed | ( | Real | x | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getTime_0_X | ( | Real | x | ) | const`[virtual]`

virtual Vector4 Ogre::AutoParamDataSource::getTime_0_X_packed | ( | Real | x | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeProjectionMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeViewMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeViewProjMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeWorldMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeWorldViewMatrix | ( |  | ) | const`[virtual]`

virtual Matrix4 Ogre::AutoParamDataSource::getTransposeWorldViewProjMatrix | ( |  | ) | const`[virtual]`

virtual Vector3 Ogre::AutoParamDataSource::getViewDirection | ( |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getViewMatrix | ( | void |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getViewportHeight | ( |  | ) | const`[virtual]`

virtual Real Ogre::AutoParamDataSource::getViewportWidth | ( |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getViewProjectionMatrix | ( | void |  | ) | const`[virtual]`

virtual Vector3 Ogre::AutoParamDataSource::getViewSideVector | ( |  | ) | const`[virtual]`

virtual Vector3 Ogre::AutoParamDataSource::getViewUpVector | ( |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getWorldMatrix | ( | void |  | ) | const`[virtual]`

virtual const Matrix4* Ogre::AutoParamDataSource::getWorldMatrixArray | ( | void |  | ) | const`[virtual]`

virtual size_t Ogre::AutoParamDataSource::getWorldMatrixCount | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getWorldViewMatrix | ( | void |  | ) | const`[virtual]`

virtual const Matrix4& Ogre::AutoParamDataSource::getWorldViewProjMatrix | ( | void |  | ) | const`[virtual]`

virtual bool Ogre::AutoParamDataSource::hasLightList | ( |  | ) | const`[virtual]`

Definition at line 173 of file OgreAutoParamDataSource.h.

virtual void Ogre::AutoParamDataSource::incPassNumber | ( | void |  | ) | `[virtual]`

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::AutoParamDataSource::setAmbientLightColour | ( | const ColourValue & | ambient | ) | `[virtual]`

virtual void Ogre::AutoParamDataSource::setCurrentCamera | ( | const Camera * | cam,
|  | bool | useCameraRelative |
| ) |  |  | `[virtual]`

Updates the current camera.

virtual void Ogre::AutoParamDataSource::setCurrentLightList | ( | const LightList * | ll | ) | `[virtual]`

Sets the light list that should be used, and it's base index from the global list.

virtual void Ogre::AutoParamDataSource::setCurrentPass | ( | const Pass * | pass | ) | `[virtual]`

Sets the current pass.

virtual void Ogre::AutoParamDataSource::setCurrentRenderable | ( | const Renderable * | rend | ) | `[virtual]`

Updates the current renderable.

virtual void Ogre::AutoParamDataSource::setCurrentRenderTarget | ( | const RenderTarget * | target | ) | `[virtual]`

Sets the current render target.

virtual void Ogre::AutoParamDataSource::setCurrentSceneManager | ( | const SceneManager * | sm | ) | `[virtual]`

Set the current scene manager for enquiring on demand.

virtual void Ogre::AutoParamDataSource::setCurrentViewport | ( | const Viewport * | viewport | ) | `[virtual]`

Sets the current viewport.

virtual void Ogre::AutoParamDataSource::setFog | ( | FogMode | mode,
|  | const ColourValue & | colour,
|  | Real | expDensity,
|  | Real | linearStart,
|  | Real | linearEnd |
| ) |  |  | `[virtual]`

virtual void Ogre::AutoParamDataSource::setMainCamBoundsInfo | ( | VisibleObjectsBoundsInfo * | info | ) | `[virtual]`

Sets the main camera's scene bounding information.

virtual void Ogre::AutoParamDataSource::setPassNumber | ( | const int | passNumber | ) | `[virtual]`

virtual void Ogre::AutoParamDataSource::setShadowDirLightExtrusionDistance | ( | Real | dist | ) | `[virtual]`

Sets the shadow extrusion distance to be used for point lights.

virtual void Ogre::AutoParamDataSource::setTextureProjector | ( | const Frustum * | frust,
|  | size_t | index |
| ) |  |  | `[virtual]`

Sets the current texture projector for a index.

virtual void Ogre::AutoParamDataSource::setWorldMatrices | ( | const Matrix4 * | m,
|  | size_t | count |
| ) |  |  | `[virtual]`

Sets the world matrices, avoid query from renderable again.

virtual void Ogre::AutoParamDataSource::updateLightCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params |
| ) |  |  | const`[virtual]`

## Member Data Documentation

ColourValue Ogre::AutoParamDataSource::mAmbientLight`[mutable, protected]`

Definition at line 106 of file OgreAutoParamDataSource.h.

Light Ogre::AutoParamDataSource::mBlankLight`[protected]`

Definition at line 127 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mCameraPosition`[mutable, protected]`

Definition at line 75 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mCameraPositionDirty`[mutable, protected]`

Definition at line 99 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mCameraPositionObjectSpace`[mutable, protected]`

Definition at line 76 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mCameraPositionObjectSpaceDirty`[mutable, protected]`

Definition at line 100 of file OgreAutoParamDataSource.h.

Vector3 Ogre::AutoParamDataSource::mCameraRelativePosition`[protected]`

Definition at line 118 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mCameraRelativeRendering`[protected]`

Definition at line 117 of file OgreAutoParamDataSource.h.

const Camera* Ogre::AutoParamDataSource::mCurrentCamera`[protected]`

Definition at line 116 of file OgreAutoParamDataSource.h.

const LightList* Ogre::AutoParamDataSource::mCurrentLightList`[protected]`

Definition at line 119 of file OgreAutoParamDataSource.h.

const Pass* Ogre::AutoParamDataSource::mCurrentPass`[protected]`

Definition at line 125 of file OgreAutoParamDataSource.h.

const Renderable* Ogre::AutoParamDataSource::mCurrentRenderable`[protected]`

Definition at line 115 of file OgreAutoParamDataSource.h.

const RenderTarget* Ogre::AutoParamDataSource::mCurrentRenderTarget`[protected]`

Definition at line 121 of file OgreAutoParamDataSource.h.

const SceneManager* Ogre::AutoParamDataSource::mCurrentSceneManager`[protected]`

Definition at line 123 of file OgreAutoParamDataSource.h.

const Frustum* Ogre::AutoParamDataSource::mCurrentTextureProjector[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[protected]`

Definition at line 120 of file OgreAutoParamDataSource.h.

const Viewport* Ogre::AutoParamDataSource::mCurrentViewport`[protected]`

Definition at line 122 of file OgreAutoParamDataSource.h.

Real Ogre::AutoParamDataSource::mDirLightExtrusionDistance`[mutable, protected]`

Definition at line 84 of file OgreAutoParamDataSource.h.

ColourValue Ogre::AutoParamDataSource::mFogColour`[mutable, protected]`

Definition at line 107 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mFogParams`[mutable, protected]`

Definition at line 108 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mInverseTransposeWorldMatrix`[mutable, protected]`

Definition at line 73 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mInverseTransposeWorldMatrixDirty`[mutable, protected]`

Definition at line 97 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mInverseTransposeWorldViewMatrix`[mutable, protected]`

Definition at line 74 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mInverseTransposeWorldViewMatrixDirty`[mutable, protected]`

Definition at line 98 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mInverseViewMatrix`[mutable, protected]`

Definition at line 72 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mInverseViewMatrixDirty`[mutable, protected]`

Definition at line 96 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mInverseWorldMatrix`[mutable, protected]`

Definition at line 70 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mInverseWorldMatrixDirty`[mutable, protected]`

Definition at line 94 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mInverseWorldViewMatrix`[mutable, protected]`

Definition at line 71 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mInverseWorldViewMatrixDirty`[mutable, protected]`

Definition at line 95 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mLodCameraPosition`[mutable, protected]`

Definition at line 85 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mLodCameraPositionDirty`[mutable, protected]`

Definition at line 112 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mLodCameraPositionObjectSpace`[mutable, protected]`

Definition at line 86 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mLodCameraPositionObjectSpaceDirty`[mutable, protected]`

Definition at line 113 of file OgreAutoParamDataSource.h.

const VisibleObjectsBoundsInfo* Ogre::AutoParamDataSource::mMainCamBoundsInfo`[protected]`

Definition at line 124 of file OgreAutoParamDataSource.h.

int Ogre::AutoParamDataSource::mPassNumber`[mutable, protected]`

Definition at line 109 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mProjectionMatrix`[mutable, protected]`

Definition at line 83 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mProjMatrixDirty`[mutable, protected]`

Definition at line 90 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mSceneDepthRange`[mutable, protected]`

Definition at line 110 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mSceneDepthRangeDirty`[mutable, protected]`

Definition at line 111 of file OgreAutoParamDataSource.h.

Vector4 Ogre::AutoParamDataSource::mShadowCamDepthRanges[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 81 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mShadowCamDepthRangesDirty[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 105 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mSpotlightViewProjMatrix[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 79 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mSpotlightViewProjMatrixDirty[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 103 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mSpotlightWorldViewProjMatrix[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 80 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mSpotlightWorldViewProjMatrixDirty[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 104 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mTextureViewProjMatrix[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 77 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mTextureViewProjMatrixDirty[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 101 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mTextureWorldViewProjMatrix[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 78 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mTextureWorldViewProjMatrixDirty[OGRE_MAX_SIMULTANEOUS_LIGHTS]`[mutable, protected]`

Definition at line 102 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mViewMatrix`[mutable, protected]`

Definition at line 82 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mViewMatrixDirty`[mutable, protected]`

Definition at line 89 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mViewProjMatrix`[mutable, protected]`

Definition at line 68 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mViewProjMatrixDirty`[mutable, protected]`

Definition at line 92 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mWorldMatrix[256]`[mutable, protected]`

Definition at line 64 of file OgreAutoParamDataSource.h.

const Matrix4* Ogre::AutoParamDataSource::mWorldMatrixArray`[mutable, protected]`

Definition at line 66 of file OgreAutoParamDataSource.h.

size_t Ogre::AutoParamDataSource::mWorldMatrixCount`[mutable, protected]`

Definition at line 65 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mWorldMatrixDirty`[mutable, protected]`

Definition at line 88 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mWorldViewMatrix`[mutable, protected]`

Definition at line 67 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mWorldViewMatrixDirty`[mutable, protected]`

Definition at line 91 of file OgreAutoParamDataSource.h.

Matrix4 Ogre::AutoParamDataSource::mWorldViewProjMatrix`[mutable, protected]`

Definition at line 69 of file OgreAutoParamDataSource.h.

bool Ogre::AutoParamDataSource::mWorldViewProjMatrixDirty`[mutable, protected]`

Definition at line 93 of file OgreAutoParamDataSource.h.

The documentation for this class was generated from the following file:

- OgreAutoParamDataSource.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:53